# Geometric utility methods
#    Copyright 2010 Benet Devereux
#    This file is part of batholith.
#    The program 'batholith' is free software: you can redistribute it and/or modify
#     it under the terms of the GNU Lesser General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
# 
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU Lesser General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.

direction_vectors = [ (-1,-1), (0, -1), (1, -1), (1, 0), (1, 1), (0,1), (-1, 1), (-1, 0)]
rookwise_direction_vectors = [ (1,0), (-1,0), (0,1), (0,-1)]

def pythagorean_d(x, y):
    sum = 0
    if len(x) != len(y):
        raise ValueError('vectors must have same dimensions')
    for i in range(len(x)):
        d = x[0]-y[0]
        sum += d*d
    return math.sqrt(sum)

def rotate_left(v):
    '''Rotate a direction vector 90deg left.
    1,0 -> 0, -1; -1, 0 -> 0, 1;
    0,1 -> 1, 0; 0, -1 -> -1, 0'''
    if v[1]:
       return [v[1], 0]
    else: # vx != 0
       return [0, -v[0]]

def rotate_right(v):
    '''Rotate a direction vector 90deg right.
    1,0 -> 0, 1; -1, 0 -> 0, -1;
    0,1 -> -1, 0; 0, -1 -> 1, 0'''
    if v[1]:
       return [-v[1], 0]
    else: # vx != 0
       return [0, v[0]]  